Version 1.4
===========

Highlights
----------

Bug-fixes
---------

Non-backwards compatible changes
--------------------------------

### Changes to binary trees

* Binary trees now have two parameters, the first being the type of node
  labels, and the second being the type of leaf labels.
* **Changes Required**
Instead of using `Tree A` from `Data.Tree.Binary`, you now must use
`Tree A ⊤` to get the same functionality.

`map` now requires a function on both nodes and leaves. There are also
`mapₙ` and `mapₗ` which only map on nodes and leaves respectively. There
are similar changes for `Data.Tree.Relation.Unary.All`.

Deprecated modules
------------------

Deprecated names
----------------

New modules
-----------

* Zippers for binary trees.

```agda
Data.Tree.Binary.Zipper
Data.Tree.Binary.Zipper.Properties
```

Other major changes
-------------------

Other minor additions
---------------------

* Added the decidablitity functions `_<‴?_`, `_≤‴?_`, `_≥‴?_`, and `_>‴?_` for deciding `≤‴` in `Data.Nat.Properties`.

* Moved `≡-dec` from `Data.Product.Properties.WithK` to `Data.Product.Properties`. The proof has been changed so that is uses that decidability implies UIP and no longer uses axiom K. Functions `injectiveʳ-≡` and `injectiveʳ-UIP` have also been added to `Data.Product.Properties`. Aliases have been added to `Data.Product.Properties.WithK` though there could be clashes in code which imports both modules.

* Added new proofs to `Data.Integer.Properties`:
  ```agda
  <⇒≢ : _<_ ⇒ _≢_
  <⇒≱ : _<_ ⇒ _≱_
  ≤⇒≯ : _≤_ ⇒ _≯_
  ≮⇒≥ : _≮_ ⇒ _≥_
  ```

* Added new proofs to `Data.Rational.Unnormalised.Properties`:
  ```agda
  positive⇒nonNegative : ∀ {q} → Positive q → NonNegative q
  negative⇒nonPositive : ∀ {q} → Negative q → NonPositive q

  neg-involutive-≡     : Involutive _≡_ (-_)
  neg-involutive       : Involutive _≃_ (-_)
  neg-mono-<->         : -_ Preserves  _<_ ⟶ _>_

  drop-*<*             : ∀ {p q} → p < q → (↥ p ℤ.* ↧ q) ℤ.< (↥ q ℤ.* ↧ p)
  <⇒≤                  : _<_ ⇒ _≤_
  <⇒≢                  : _<_ ⇒ _≢_
  <⇒≱                  : _<_ ⇒ _≱_
  ≰⇒>                  : _≰_ ⇒ _>_
  ≮⇒≥                  : _≮_ ⇒ _≥_

  ≤-preorder             : Preorder 0ℓ 0ℓ 0ℓ
  ≤-poset                : Poset 0ℓ 0ℓ 0ℓ
  ≤-totalOrder           : TotalOrder 0ℓ 0ℓ 0ℓ

  <-irrefl-≡           : Irreflexive _≡_ _<_
  <-irrefl             : Irreflexive _≃_ _<_
  <-asym               : Asymmetric _<_
  ≤-<-trans            : Trans _≤_ _<_ _<_
  <-≤-trans            : Trans _<_ _≤_ _<_
  <-trans              : Transitive _<_
  <-cmp                : Trichotomous _≃_ _<_
  _<?_                 : Decidable _<_
  <-irrelevant         : Irrelevant _<_
  <-respʳ-≃            : _<_ Respectsʳ _≃_
  <-respˡ-≃            : _<_ Respectsˡ _≃_
  <-resp-≃             : _<_ Respects₂ _≃_

  <-strictPartialOrder-≡ : StrictPartialOrder 0ℓ 0ℓ 0ℓ
  <-strictPartialOrder   : StrictPartialOrder 0ℓ 0ℓ 0ℓ
  <-strictTotalOrder     : StrictTotalOrder 0ℓ 0ℓ 0ℓ
  <-isStrictPartialOrder-≡ : IsStrictPartialOrder _≡_ _<_
  <-isStrictPartialOrder   : IsStrictPartialOrder _≃_ _<_
  <-isStrictTotalOrder     : IsStrictTotalOrder _≃_ _<_

  ≥0⇒↥≥0               : ∀ {n dm} → mkℚᵘ n dm ≥ 0ℚᵘ → n ℤ.≥ 0ℤ
  >0⇒↥>0               : ∀ {n dm} → mkℚᵘ n dm > 0ℚᵘ → n ℤ.> 0ℤ

  positive⁻¹           : ∀ {q} → Positive q → q > 0ℚᵘ
  nonNegative⁻¹        : ∀ {q} → NonNegative q → q ≥ 0ℚᵘ
  negative⁻¹           : ∀ {q} → Negative q → q < 0ℚᵘ
  nonPositive⁻¹        : ∀ {q} → NonPositive q → q ≤ 0ℚᵘ
  negative<positive    : ∀ {p q} → Negative p → Positive q → p < q

  +-congʳ              : ∀ p {q r} → q ≃ r → p + q ≃ p + r
  +-congˡ              : ∀ p {q r} → q ≃ r → q + p ≃ r + p

  +-cancelˡ            : ∀ {r p q} → r + p ≃ r + q → p ≃ q
  +-cancelʳ            : ∀ {r p q} → p + r ≃ q + r → p ≃ q

  neg-distrib-+        : ∀ p q → - (p + q) ≡ (- p) + (- q)
  +-monoʳ-≤            : ∀ r → (r +_) Preserves _≤_ ⟶ _≤_
  +-monoˡ-≤            : ∀ r → (_+ r) Preserves _≤_ ⟶ _≤_
  +-mono-≤             : _+_ Preserves₂ _≤_ ⟶ _≤_ ⟶ _≤_
  ≤-steps              : ∀ {p q r} → NonNegative r → p ≤ q → p ≤ r + q
  p≤p+q                : ∀ {p q} → NonNegative q → p ≤ p + q
  p≤q+p                : ∀ {p} → NonNegative p → ∀ {q} → q ≤ p + q

  +-monoʳ-<            : ∀ r → (r +_) Preserves _<_ ⟶ _<_
  +-monoˡ-<            : ∀ r → (_+ r) Preserves _<_ ⟶ _<_
  +-mono-<             : _+_ Preserves₂ _<_ ⟶ _<_ ⟶ _<_
  +-mono-≤-<           : _+_ Preserves₂ _≤_ ⟶ _<_ ⟶ _<_
  +-mono-<-≤           : _+_ Preserves₂ _<_ ⟶ _≤_ ⟶ _<_

  +-minus-telescope    : ∀ p q r → (p - q) + (q - r) ≃ p - r
  p≃q⇒p-q≃0            : ∀ p q → p ≃ q → p - q ≃ 0ℚᵘ
  p-q≃0⇒p≃q            : ∀ p q → p - q ≃ 0ℚᵘ → p ≃ q
  neg-mono-≤-≥         : -_ Preserves _≤_ ⟶ _≥_
  p≤q⇒p-q≤0            : ∀ {p q} → p ≤ q → p - q ≤ 0ℚᵘ
  p-q≤0⇒p≤q            : ∀ {p q} → p - q ≤ 0ℚᵘ → p ≤ q
  p≤q⇒0≤q-p            : ∀ {p q} → p ≤ q → 0ℚᵘ ≤ q - p
  0≤q-p⇒p≤q            : ∀ {p q} → 0ℚᵘ ≤ q - p → p ≤ q

  *-inverseˡ           : ∀ p {p≢0 : ℤ.∣ ↥ p ∣ ≢0} → 1/_ p {p≢0} * p ≃ 1ℚᵘ
  *-inverseʳ           : ∀ p {p≢0 : ℤ.∣ ↥ p ∣ ≢0} → p * 1/_ p {p≢0} ≃ 1ℚᵘ

  neg-distribˡ-*       : ∀ p q → - (p * q) ≃ - p * q
  neg-distribʳ-*       : ∀ p q → - (p * q) ≃ p * - q

  *-cancelʳ-≤-pos      : ∀ {r} → Positive r → ∀ {p q} → p * r ≤ q * r → p ≤ q
  *-cancelˡ-≤-pos      : ∀ {r} → Positive r → ∀ {p q} → r * p ≤ r * q → p ≤ q
  *-monoʳ-≤-nonNeg     : ∀ {r} → NonNegative r → (r *_) Preserves _≤_ ⟶ _≤_
  *-monoˡ-≤-nonNeg     : ∀ {r} → NonNegative r → (_* r) Preserves _≤_ ⟶ _≤_
  *-monoʳ-≤-pos        : ∀ {r} → Positive r → (r *_) Preserves _≤_ ⟶ _≤_
  *-monoˡ-≤-pos        : ∀ {r} → Positive r → (_* r) Preserves _≤_ ⟶ _≤_

  *-monoˡ-<-pos        : ∀ {r} → Positive r → (_* r) Preserves _<_ ⟶ _<_
  *-monoʳ-<-pos        : ∀ {r} → Positive r → (r *_) Preserves _<_ ⟶ _<_
  *-cancelˡ-<-nonNeg   : ∀ {r} → NonNegative r → {p q} → r * p < r * q → p < q
  *-cancelʳ-<-nonNeg   : ∀ {r} → NonNegative r → {p q} → p * r < q * r → p < q
  ```

* Added module `≤-Reasoning` to `Data.Rational.Unnormalised.Properties`
